﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridSelectFromOneColumn
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            DataTable table = new DataTable();
            table.Columns.Add("Number1", typeof(int));
            table.Columns.Add("Number2", typeof(int));

            for(int i=0; i<10; i++)
            {
                DataRow row = table.NewRow();
                row[0] = r.Next(1000);
                row[1] = r.Next(1000);

                table.Rows.Add(row);
            }

            ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            ultraGrid1.BeforeSelectChange += UltraGrid1_BeforeSelectChange;
            ultraGrid1.DataSource = table;            
        }

        private void UltraGrid1_BeforeSelectChange(object sender, Infragistics.Win.UltraWinGrid.BeforeSelectChangeEventArgs e)
        {
            if(ultraGrid1.Selected.Cells.Count != 0)
            {
                UltraGridCell firstSelectedCell = ultraGrid1.Selected.Cells[0];
                UltraGridColumn column = firstSelectedCell.Column;

                bool cancel = false;

                foreach(UltraGridCell cell in e.NewSelections.Cells)
                {
                    if(cell.Column != column)
                    {
                        cancel = true;
                        break;
                    }
                }

                e.Cancel = cancel;
            }
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.CellSelect;
        }
    }
}
